import time
print(time.strftime("%H:%M:%S"))
import math
import arcpy
import numpy as np

def RzutPunktuNaProsta(x, y, a, b):
    if a != 0.0:
        aa = -(1.0/a)
        bb = y - aa * x
        xx = (bb - b)/(a - aa)
        yy = a * xx + b
        return [xx, yy]
def AproksymacjaProstej(TableCoordinates, XMin, YMin):
    SumaXY = TableCoordinates.sum(axis=0)
    SX2 = np.sum(np.power(TableCoordinates[:, 0], 2))
    SXY = np.sum(TableCoordinates[:, 0] * TableCoordinates[:, 1])
    a = (len(TableCoordinates) * SXY - SumaXY[0] * SumaXY[1])/(len(TableCoordinates)*SX2 - SumaXY[0] * SumaXY[0])
    b = (SumaXY[1] * SX2 - SumaXY[0] * SXY)/(len(TableCoordinates)*SX2 - SumaXY[0] * SumaXY[0])
    BB = TableCoordinates[:, 1] - (np.array([-(1.0/a)], dtype=float) * TableCoordinates[:, 0])
    XX = (BB - np.array([b], dtype=float))/(np.array([a], dtype=float) - np.array([-(1.0/a)], dtype=float))
    YY = np.array([a], dtype=float) * XX + np.array([b], dtype=float)
    NewXY = np.concatenate((np.array([XX]).transpose(), np.array([YY]).transpose()), axis=1)
    DXY2 = np.power((TableCoordinates - NewXY), 2)
    SDXY = np.sqrt((DXY2[:, 0] + DXY2[:, 1]))
    feature = [[NewXY[0, 0] + XMin, NewXY[0, 1] + YMin], [NewXY[-1, 0] + XMin, NewXY[-1, 1] + YMin]]
    LineGeometry = arcpy.Polyline(arcpy.Array([arcpy.Point(*coords) for coords in feature]))
    return [SDXY, NewXY, LineGeometry]
def AproksymacjaLuku(TableCoordinates, XMin, YMin):
    A = np.zeros((3, 3))
    Y = np.zeros((3, 1))
    Sx = np.sum(TableCoordinates[:, 1])
    Sy = np.sum(TableCoordinates[:, 0])
    Sx2 = np.sum(np.power(TableCoordinates[:, 1], 2))
    Sy2 = np.sum(np.power(TableCoordinates[:, 0], 2))
    Sxy = np.sum(TableCoordinates[:, 0] * TableCoordinates[:, 1])
    Sx3 = np.sum(np.power(TableCoordinates[:, 1], 3))
    Sy3 = np.sum(np.power(TableCoordinates[:, 0], 3))
    Sxy2 = np.sum(TableCoordinates[:, 1] * np.power(TableCoordinates[:, 0], 2))
    Sx2y = np.sum(TableCoordinates[:, 0] * np.power(TableCoordinates[:, 1], 2))
    A[0, 0] = len(TableCoordinates)
    A[0, 1] = Sx
    A[1, 0] = Sx
    A[1, 1] = Sx2
    A[0, 2] = Sy
    A[2, 0] = Sy
    A[1, 2] = Sxy
    A[2, 1] = Sxy
    A[2, 2] = Sy2
    Y[0, 0] = -Sx2 - Sy2
    Y[1, 0] = -Sx3 - Sxy2
    Y[2, 0] = -Sx2y - Sy3
    A_1 = np.linalg.inv(A)
    L = np.dot(A_1, Y)
    a = -(L[1, 0]/2)
    b = -(L[2, 0]/2)
    c = L[0, 0]
    r = math.sqrt(a*a+b*b-c)
    aa = XMin + b
    bb = YMin + a
    point = arcpy.Point()
    point.X, point.Y = aa, bb
    pointGeometry1 = arcpy.PointGeometry(point)
    GeoB = pointGeometry1.buffer(r)
    GeoBB = GeoB.boundary()
    ddxy = []
    point = arcpy.Point()
    for i in range(len(TableCoordinates)):
        point.X, point.Y = TableCoordinates[i, 0] + XMin, TableCoordinates[i, 1] + YMin
        pointGeometry = arcpy.PointGeometry(point)
        dd = pointGeometry.distanceTo(GeoBB)
        ddxy += [dd]
    DXY = np.array(ddxy, dtype=float)
    ddxy2 = np.power(ddxy, 2)
    ddxy2s = np.sum(ddxy2)
    sxy = math.sqrt((1/(len(TableCoordinates)-2.))*ddxy2s)
    return [GeoBB, DXY, pointGeometry1, r]

arcpy.env.workspace = geoworkspace = r"D:\Badania\DrogiGPS\Dane251116\DaneAll.gdb"
Droga = "A03_Jezdnia01_1"
DrogaPkt = Droga + "_T01"

ListCoor = []
cursor = arcpy.da.SearchCursor(Droga, ["SHAPE@X", "SHAPE@Y", "curve"])
for row in cursor:
    ListCoor += [row[0], row[1], row[2]]
CountL = len(ListCoor)/3
ListCoor = np.array(ListCoor, float)
XYC = ListCoor.reshape((CountL, 3))

CS1 = np.array(XYC[1:, 2], dtype=int)## Brak pierwszego rekordu
CE1 = np.array(XYC[:-1, 2], dtype=int)## Brak ostatniego rekordu
G = np.where(np.array(XYC[:-1, 2], dtype=int) != np.array(XYC[1:, 2], dtype=int))
GC = np.array(XYC[:, 2].take(G[0], axis=0), dtype=int)
GC = np.concatenate((GC, [GC[-2]]))
G = np.concatenate((G[0], [CountL])) + 1
Start = 0

AddLG = []
AddLP = []
AddPG = []
AddLD = []
for i in range(len(G) - 1):
    Barrier1 = G[i]
    Barrier2 = G[i + 1]
    XYall = XYC[Start:Barrier2, :2]
    ProstaXY = XYall[Start:Barrier1, :2]
    MinXYall = XYall.min(axis=0)
    XYall = XYall - MinXYall
    print(Start, Barrier1, Barrier2)
    if GC[i] == 0:
        BS1P = Barrier1 - Start + 1
        BS1L = Barrier1 - Start
        BS2 = Barrier2 - Start
        ProstaXY = XYall[0:BS1P, :2]
        LukXY = XYall[BS1L:BS2, :2]
        # print "Prosta - Luk", Start, Barrier1, Barrier2
        AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
        AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
        DP = AP[0][-1]
        DL = AL[1][0]
        if DP < DL:
            while DP < DL and len(ProstaXY) > 3 and len(LukXY) > 4:
                BS1L += 1
                BS1P += 1
                ProstaXY = XYall[0:BS1P, :2]
                LukXY = XYall[BS1L:BS2, :2]
                AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
                AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
                DP = AP[0][-1]
                DL = AL[1][0]
            G.put([i], np.array([Start + BS1P], dtype=int))
        else:
            while DP > DL and len(ProstaXY) > 3 and len(LukXY) > 4:
                BS1L -= 1
                BS1P -= 1
                ProstaXY = XYall[0:BS1P, :2]
                LukXY = XYall[BS1L:BS2, :2]
                AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
                AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
                DP = AP[0][-1]
                DL = AL[1][0]
            G.put([i], np.array([Start + BS1P], dtype=int))
    else:
        BS1L = Barrier1 - Start + 1
        BS1P = Barrier1 - Start
        BS2 = Barrier2 - Start
        LukXY = XYall[0:BS1L, :2]
        ProstaXY = XYall[BS1P:BS2, :2]
        AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
        AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
        DL = AL[1][-1]
        DP = AP[0][0]
        if DL < DP:
            while DL < DP and len(ProstaXY) > 3 and len(LukXY) > 4:
                BS1L += 1
                BS1P += 1
                LukXY = XYall[0:BS1L, :2]
                ProstaXY = XYall[BS1P:BS2, :2]
                AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
                AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
                DL = AL[1][-1]
                DP = AP[0][0]
            G.put([i], np.array([Start + BS1P], dtype=int))
        else:
            while DL > DP and len(ProstaXY) > 3 and len(LukXY) > 4:
                BS1L -= 1
                BS1P -= 1
                LukXY = XYall[0:BS1L, :2]
                ProstaXY = XYall[BS1P:BS2, :2]
                AL = AproksymacjaLuku(LukXY, MinXYall[0], MinXYall[1])
                AP = AproksymacjaProstej(ProstaXY, MinXYall[0], MinXYall[1])
                DL = AL[1][-1]
                DP = AP[0][0]
            G.put([i], np.array([Start + BS1P], dtype=int))
    AddLG += [AL[0]]
    AddPG += [AP[2]]
    AddLP += [AL[2]]
    AddLD += [AL[3]]
    Start = Barrier1
NN = AP[1] + MinXYall
print(NN[0, :])
PP = "Prosta01"
arcpy.CreateFeatureclass_management(arcpy.env.workspace,PP,"POLYLINE","#","DISABLED","DISABLED","A02_Jezdnia01_1")
cursor = arcpy.da.InsertCursor(PP, ["SHAPE@"])
for GeoP in AddPG:
    cursor.insertRow([GeoP])
del cursor

i = 0
LL = "Luk01"
arcpy.CreateFeatureclass_management(arcpy.env.workspace,LL,"POLYLINE","#","DISABLED","DISABLED","A02_Jezdnia01_1")
arcpy.AddField_management(LL, "dd", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
cursor = arcpy.da.InsertCursor(LL, ["SHAPE@", "dd"])
for GeoL in AddLG:
    cursor.insertRow([GeoL, AddLD[i]])
    i += 1
LP = "PunktyNaLuk0"
arcpy.CreateFeatureclass_management(arcpy.env.workspace,LP,"POINT","#","DISABLED","DISABLED","A02_Jezdnia01_1")
cursor = arcpy.da.InsertCursor(LP, ["SHAPE@"])
for GeoLP in AddLP:
    cursor.insertRow([GeoLP])


print("KONIEC")
